//--------------------------------------------------------------------------------------
function string PideTexto(string sCadena)

private
	string sCadenaAntigua="";
	int iContador;
	string sPantalla;
	int iLongitudTexto;
	int iPosicionCursor;
	int iValorAntiguoBarra;
	int iTamanoEnPixelDelSalto;
	int iDiferencia;
	int iLuz;
	int iIdeCadena;
	string sTecla;
	int iPosicionPantalla=0;
	byte bLuzVerde=1;
	byte bSeparacin;
	byte bAnchoBoton;
	byte bAltoBoton;
	byte bFila=0;
	byte bInicioFila;
	string sCaja;
	int iCoordenadaY;
	int iIdeDraw[10];
	BarraDeslizante_Horizontal iBarraDeslizante=0;
	BarraDeslizante_Horizontal iBarraDeslizanteTemporal=0;
	Boton iBotonBorrar;
	Boton iBotonSh;
	Boton iBotonOK;
	Boton iBotonCancel;
	Boton iBoton[50];
	byte bCaracteres=47; // n total de teclas en pantalla con carcteres.
	string sBoton[47][2]=
	" "," "," A", //0
	" "," "," B", //1
	" "," "," C", //2
	" "," "," D", //3
	" "," "," E", //4
	" "," "," F", //5
	" "," "," G", //6
	" "," "," H", //7
	" "," "," I", //8
	" "," "," J", //9
	" "," "," K", //10
	" "," "," L", //11
	" "," "," M", //12
	" "," "," N", //13
	" "," "," ", //14
	" "," "," O", //15
	" "," "," P", //16
	" "," "," Q", //17
	" "," "," R", //18
	" "," "," S", //19
	" "," "," T", //20
	" "," "," U", //21
	" "," "," V", //22
	" "," "," W", //23
	" "," "," X", //24
	" "," "," Y", //25
	" "," "," Z", //26
	"!"," "," 1", //27
	'"'," "," 2", //28
	"#"," "," 3", //29
	"$"," "," 4", //30
	"%"," "," 5", //31
	"&"," "," 6", //32
	"/"," "," 7", //33
	"("," "," 8", //34
	")"," "," 9", //35
	"="," "," 0", //36
	"?"," ","'", //37
	""," ","", //38
	"+"," ","[", //39
	"*"," ","]", //40
	""," ","{", //41
	"\"," ","}", //42
	";"," ",",", //43
	":"," ",".", //44
	"_"," ","-", //45
	">"," ","<", //46
	""," ",""; //47

	string sCaracter[47][1]=
	"A","a", //0
	"B","b", //1
	"C","c", //2
	"D","d", //3
	"E","e", //4
	"F","f", //5
	"G","g", //6
	"H","h", //7
	"I","i", //8
	"J","j", //9
	"K","k", //10
	"L","l", //11
	"M","m", //12
	"N","n", //13
	"","", //14
	"O","o", //15
	"P","p", //16
	"Q","q", //17
	"R","r", //18
	"S","s", //19
	"T","t", //20
	"U","u", //21
	"V","v", //22
	"W","w", //23
	"X","x", //24
	"Y","y", //25
	"Z","z", //26
	"!","1", //27
	'"',"2", //28
	"#","3", //29
	"$","4", //30
	"%","5", //31
	"&","6", //32
	"/","7", //33
	"(","8", //34
	")","9", //35
	"=","0", //36
	"?","'", //37
	"","", //38
	"+","[", //39
	"*","]", //40
	"","{", //41
	"\","}", //42
	";",",", //43
	":",".", //44
	"_","-", //45
	">","<", //46
	"",""; //47
	
	string sBotonMay	[0]="May";
	string sBotonSh		[1]=" ","";
	string sBotonOK		[1]=" ","OK";
	string sBotonCancel	[1]=" ","Quit";
	Cursor iCursor;
end

// ABECEDARIO
//A  B  C  D  E  F  G  H  I  J  K  L  M  N  O  P  Q  R  S  T  U  V  W  X  Y  Z  
//1  2  3  4  5  6  7  8  9  10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27

begin
	iDrawingZZ=iDrawingZZ-500;
	iTextZ=iTextZ-540;
	drawing_z(iDrawingZZ);  // Coordenadas de dibujo muy altas para asegurarnos que se ve el botn.
	Text_Z=iTextz;
	signal(ALL_PROCESS,s_freeze);
	sPantalla=sCadena;
	iLongitudTexto=len(sCadena); //Valor de iBarraDeslizante.
	iValorAntiguoBarra=0; //Valor anterior de iBarraDeslizante cuando hay un cambio.
	iPosicionCursor=0;	//Posicin del cursor en el caracter..
	//Inicializo caja de texto.
	drawing_z(iDrawingZZ+50);
	drawing_color(rgb(10,36,106));
	iIdeDraw[0]=draw_box(0,0,320,15);
	drawing_color(rgb(100,100,100));
	iIdeDraw[1]=draw_box(0,11,320,240);
	Text_z=iTextZ-50;
	sPantalla=sCadena;//Cadena que se muestra en la pantalla
	set_text_color(rgb(255,255,255));
	iIdeCadena=write_var(0,2,8,3,sPantalla); //Escribo Cadena.
	set_text_color(rgb(0,0,0));
	//Inicializando Barra.
	iBarraDeslizante=Barra_DeslizanteHorizontal(0,320,16,15,0,0,0,0,0,iLongitudTexto,0, iDrawingZZ, iTextZ);
	iBarraDeslizante.iSalto=10;
	
	//Inicializo botones.
	bAnchoBoton=29;
	bAltoBoton=38;
	bFila=40;
	bInicioFila=3;
	bSeparacin=6;
	iCoordenadaY=bAltoBoton+10;
	iBoton[27]=boton(bAnchoBoton,bAltoBoton,&sBoton[27],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[27].iX=bInicioFila+0;
	iBoton[27].iY=bFila;
	iBoton[27].bRepintar=1;
	//2
	iCoordenadaY=bAltoBoton+10;
	iBoton[28]=boton(bAnchoBoton,bAltoBoton,&sBoton[28],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[28].iX=bInicioFila+bAnchoBoton;
	iBoton[28].iY=bFila;
	iBoton[28].bRepintar=1;
	//3
	iCoordenadaY=bAltoBoton+10;
	iBoton[29]=boton(bAnchoBoton,bAltoBoton,&sBoton[29],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[29].iX=bInicioFila+bAnchoBoton*2;
	iBoton[29].iY=bFila;
	iBoton[29].bRepintar=1;
	//4
	iCoordenadaY=bAltoBoton+10;
	iBoton[30]=boton(bAnchoBoton,bAltoBoton,&sBoton[30],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[30].iX=bInicioFila+bAnchoBoton*3;
	iBoton[30].iY=bFila;
	iBoton[30].bRepintar=1;
	//5
	iCoordenadaY=bAltoBoton+10;
	iBoton[31]=boton(bAnchoBoton,bAltoBoton,&sBoton[31],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[31].iX=bInicioFila+bAnchoBoton*4;
	iBoton[31].iY=bFila;
	iBoton[31].bRepintar=1;
	//6
	iCoordenadaY=bAltoBoton+10;
	iBoton[32]=boton(bAnchoBoton,bAltoBoton,&sBoton[32],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[32].iX=bInicioFila+bAnchoBoton*5;
	iBoton[32].iY=bFila;
	iBoton[32].bRepintar=1;
	//7
	iCoordenadaY=bAltoBoton+10;
	iBoton[33]=boton(bAnchoBoton,bAltoBoton,&sBoton[33],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[33].iX=bInicioFila+bAnchoBoton*6;
	iBoton[33].iY=bFila;
	iBoton[33].bRepintar=1;
	//8
	iCoordenadaY=bAltoBoton+10;
	iBoton[34]=boton(bAnchoBoton,bAltoBoton,&sBoton[34],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[34].iX=bInicioFila+bAnchoBoton*7;
	iBoton[34].iY=bFila;
	iBoton[34].bRepintar=1;
	//9
	iCoordenadaY=bAltoBoton+10;
	iBoton[35]=boton(bAnchoBoton,bAltoBoton,&sBoton[35],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[35].iX=bInicioFila+bAnchoBoton*8;
	iBoton[35].iY=bFila;
	iBoton[35].bRepintar=1;
	//0
	iCoordenadaY=bAltoBoton+10;
	iBoton[36]=boton(bAnchoBoton,bAltoBoton,&sBoton[36],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[36].iX=bInicioFila+bAnchoBoton*9;
	iBoton[36].iY=bFila;
	iBoton[36].bRepintar=1;
	//Borrar
	iCoordenadaY=bAltoBoton+10;
	iBotonBorrar=boton(bAnchoBoton-3,bAltoBoton,&sBotonSh,1,0,3,rgb(212,208,200),0,0,11, iDrawingZZ, iTextZ);
	iBotonBorrar.iX=bInicioFila+bAnchoBoton*10;
	iBotonBorrar.iY=bFila;
	iBotonBorrar.bScala=0;
	iBotonBorrar.Angle=90000;
	iBotonBorrar.bRepintar=1;

	//LETRAS
	bFila=bFila+bAltoBoton;
	bInicioFila=bInicioFila+bAnchoBoton/2;
	//bSeparacin=15;
	//Q
	iCoordenadaY=bAltoBoton+10;
	iBoton[17]=boton(bAnchoBoton,bAltoBoton,&sBoton[17],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[17].iX=bInicioFila+0;
	iBoton[17].iY=bFila;
	iBoton[17].bRepintar=1;
	//W
	iCoordenadaY=bAltoBoton+10;
	iBoton[23]=boton(bAnchoBoton,bAltoBoton,&sBoton[23],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[23].iX=bInicioFila+bAnchoBoton;
	iBoton[23].iY=bFila;
	iBoton[23].bRepintar=1;
	//E
	iCoordenadaY=bAltoBoton+10;
	iBoton[4]=boton(bAnchoBoton,bAltoBoton,&sBoton[4],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[4].iX=bInicioFila+bAnchoBoton*2;
	iBoton[4].iY=bFila;
	iBoton[4].bRepintar=1;
	//R
	iCoordenadaY=bAltoBoton+10;
	iBoton[18]=boton(bAnchoBoton,bAltoBoton,&sBoton[18],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[18].iX=bInicioFila+bAnchoBoton*3;
	iBoton[18].iY=bFila;
	iBoton[18].bRepintar=1;
	//T
	iCoordenadaY=bAltoBoton+10;
	iBoton[20]=boton(bAnchoBoton,bAltoBoton,&sBoton[20],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[20].iX=bInicioFila+bAnchoBoton*4;
	iBoton[20].iY=bFila;
	iBoton[20].bRepintar=1;
	//Y
	iCoordenadaY=bAltoBoton+10;
	iBoton[25]=boton(bAnchoBoton,bAltoBoton,&sBoton[25],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[25].iX=bInicioFila+bAnchoBoton*5;
	iBoton[25].iY=bFila;
	iBoton[25].bRepintar=1;
	//U
	iCoordenadaY=bAltoBoton+10;
	iBoton[21]=boton(bAnchoBoton,bAltoBoton,&sBoton[21],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[21].iX=bInicioFila+bAnchoBoton*6;
	iBoton[21].iY=bFila;
	iBoton[21].bRepintar=1;
	//I
	iCoordenadaY=bAltoBoton+10;
	iBoton[8]=boton(bAnchoBoton,bAltoBoton,&sBoton[8],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[8].iX=bInicioFila+bAnchoBoton*7;
	iBoton[8].iY=bFila;
	iBoton[8].bRepintar=1;
	//O
	iCoordenadaY=bAltoBoton+10;
	iBoton[15]=boton(bAnchoBoton,bAltoBoton,&sBoton[15],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[15].iX=bInicioFila+bAnchoBoton*8;
	iBoton[15].iY=bFila;
	iBoton[15].bRepintar=1;
	//P
	iCoordenadaY=bAltoBoton+10;
	iBoton[16]=boton(bAnchoBoton,bAltoBoton,&sBoton[16],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[16].iX=bInicioFila+bAnchoBoton*9;
	iBoton[16].iY=bFila;
	iBoton[16].bRepintar=1;
	
	
	bFila=bFila+bAltoBoton;
	bInicioFila=bInicioFila+bAnchoBoton/2;
	//OK
	iCoordenadaY=bAltoBoton+10;
	iBotonOK=boton(bAnchoBoton,bAltoBoton,&sBotonOK,2,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBotonOK.iX=bInicioFila-bAnchoBoton;
	iBotonOK.iY=bFila;
	iBotonOK.bRepintar=1;
	//A
	iCoordenadaY=bAltoBoton+10;
	iBoton[0]=boton(bAnchoBoton,bAltoBoton,&sBoton[0],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[0].iX=bInicioFila+0;
	iBoton[0].iY=bFila;
	iBoton[0].bRepintar=1;
	//S
	iCoordenadaY=bAltoBoton+10;
	iBoton[19]=boton(bAnchoBoton,bAltoBoton,&sBoton[19],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[19].iX=bInicioFila+bAnchoBoton;
	iBoton[19].iY=bFila;
	iBoton[19].bRepintar=1;
	//D
	iCoordenadaY=bAltoBoton+10;
	iBoton[3]=boton(bAnchoBoton,bAltoBoton,&sBoton[3],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[3].iX=bInicioFila+bAnchoBoton*2;
	iBoton[3].iY=bFila;
	iBoton[3].bRepintar=1;
	//F
	iCoordenadaY=bAltoBoton+10;
	iBoton[5]=boton(bAnchoBoton,bAltoBoton,&sBoton[5],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[5].iX=bInicioFila+bAnchoBoton*3;
	iBoton[5].iY=bFila;
	iBoton[5].bRepintar=1;
	//G
	iCoordenadaY=bAltoBoton+10;
	iBoton[6]=boton(bAnchoBoton,bAltoBoton,&sBoton[6],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[6].iX=bInicioFila+bAnchoBoton*4;
	iBoton[6].iY=bFila;
	iBoton[6].bRepintar=1;
	//H
	iCoordenadaY=bAltoBoton+10;
	iBoton[7]=boton(bAnchoBoton,bAltoBoton,&sBoton[7],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[7].iX=bInicioFila+bAnchoBoton*5;
	iBoton[7].iY=bFila;
	iBoton[7].bRepintar=1;
	//J
	iCoordenadaY=bAltoBoton+10;
	iBoton[9]=boton(bAnchoBoton,bAltoBoton,&sBoton[9],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[9].iX=bInicioFila+bAnchoBoton*6;
	iBoton[9].iY=bFila;
	iBoton[9].bRepintar=1;
	//K
	iCoordenadaY=bAltoBoton+10;
	iBoton[10]=boton(bAnchoBoton,bAltoBoton,&sBoton[10],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[10].iX=bInicioFila+bAnchoBoton*7;
	iBoton[10].iY=bFila;
	iBoton[10].bRepintar=1;
	//L
	iCoordenadaY=bAltoBoton+10;
	iBoton[11]=boton(bAnchoBoton,bAltoBoton,&sBoton[11],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[11].iX=bInicioFila+bAnchoBoton*8;
	iBoton[11].iY=bFila;
	iBoton[11].bRepintar=1;
	//Cancel
	iCoordenadaY=bAltoBoton+10;
	iBotonCancel=boton(bAnchoBoton-2,bAltoBoton,&sBotonCancel,2,iFuenteBlack,3,rgb(212,208,200),0,2,0, iDrawingZZ, iTextZ);
	iBotonCancel.iX=bInicioFila+bAnchoBoton*9;
	iBotonCancel.iY=bFila;
	iBotonCancel.bRepintar=1;

	
	
	
	bFila=bFila+bAltoBoton;
	bInicioFila=bInicioFila+bAnchoBoton/2;
	//Sh
	iCoordenadaY=bAltoBoton+10;
	iBotonSh=boton(bAnchoBoton,bAltoBoton,&sBotonSh,1,0,3,rgb(212,208,200),0,0,11, iDrawingZZ, iTextZ);
	iBotonSh.iX=bInicioFila-bAnchoBoton;
	iBotonSh.iY=bFila;
	iBotonSh.bScala=0;
	iBotonSh.bRepintar=1;
	Drawing_color(rgb(0,100,0));
	iLuz=Draw_fcircle(iBotonSh.iX+5,iBotonSh.iY+5,3);
	//Z
	iCoordenadaY=bAltoBoton+10;
	iBoton[26]=boton(bAnchoBoton,bAltoBoton,&sBoton[26],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[26].iX=bInicioFila+0;
	iBoton[26].iY=bFila;
	iBoton[26].bRepintar=1;
	//X
	iCoordenadaY=bAltoBoton+10;
	iBoton[24]=boton(bAnchoBoton,bAltoBoton,&sBoton[24],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[24].iX=bInicioFila+bAnchoBoton;
	iBoton[24].iY=bFila;
	iBoton[24].bRepintar=1;
	//C
	iCoordenadaY=bAltoBoton+10;
	iBoton[2]=boton(bAnchoBoton,bAltoBoton,&sBoton[2],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[2].iX=bInicioFila+bAnchoBoton*2;
	iBoton[2].iY=bFila;
	iBoton[2].bRepintar=1;
	//V
	iCoordenadaY=bAltoBoton+10;
	iBoton[22]=boton(bAnchoBoton,bAltoBoton,&sBoton[22],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[22].iX=bInicioFila+bAnchoBoton*3;
	iBoton[22].iY=bFila;
	iBoton[22].bRepintar=1;
	//B
	iCoordenadaY=bAltoBoton+10;
	iBoton[1]=boton(bAnchoBoton,bAltoBoton,&sBoton[1],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[1].iX=bInicioFila+bAnchoBoton*4;
	iBoton[1].iY=bFila;
	iBoton[1].bRepintar=1;
	//N
	iCoordenadaY=bAltoBoton+10;
	iBoton[13]=boton(bAnchoBoton,bAltoBoton,&sBoton[13],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[13].iX=bInicioFila+bAnchoBoton*5;
	iBoton[13].iY=bFila;
	iBoton[13].bRepintar=1;
	//M
	iCoordenadaY=bAltoBoton+10;
	iBoton[12]=boton(bAnchoBoton,bAltoBoton,&sBoton[12],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[12].iX=bInicioFila+bAnchoBoton*6;
	iBoton[12].iY=bFila;
	iBoton[12].bRepintar=1;
	//
	iCoordenadaY=bAltoBoton+10;
	iBoton[14]=boton(bAnchoBoton,bAltoBoton,&sBoton[14],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[14].iX=bInicioFila+bAnchoBoton*7;
	iBoton[14].iY=bFila;
	iBoton[14].bRepintar=1;
	//
	iCoordenadaY=bAltoBoton+10;
	iBoton[47]=boton(bAnchoBoton,bAltoBoton,&sBoton[47],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[47].iX=bInicioFila+bAnchoBoton*8;
	iBoton[47].iY=bFila;
	iBoton[47].bRepintar=1;


	bFila=bFila+bAltoBoton+10;
	bInicioFila=10;
	bAnchoBoton=30;
	//'
	iCoordenadaY=bAltoBoton+10;
	iBoton[37]=boton(bAnchoBoton,bAltoBoton,&sBoton[37],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[37].iX=bInicioFila;
	iBoton[37].iY=bFila;
	iBoton[37].bRepintar=1;
	//
	iCoordenadaY=bAltoBoton+10;
	iBoton[38]=boton(bAnchoBoton,bAltoBoton,&sBoton[38],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[38].iX=bInicioFila+bAnchoBoton;
	iBoton[38].iY=bFila;
	iBoton[38].bRepintar=1;
	//[
	iCoordenadaY=bAltoBoton+10;
	iBoton[39]=boton(bAnchoBoton,bAltoBoton,&sBoton[39],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[39].iX=bInicioFila+bAnchoBoton*2;
	iBoton[39].iY=bFila;
	iBoton[39].bRepintar=1;
	//]
	iCoordenadaY=bAltoBoton+10;
	iBoton[40]=boton(bAnchoBoton,bAltoBoton,&sBoton[40],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[40].iX=bInicioFila+bAnchoBoton*3;
	iBoton[40].iY=bFila;
	iBoton[40].bRepintar=1;
	//{
	iCoordenadaY=bAltoBoton+10;
	iBoton[41]=boton(bAnchoBoton,bAltoBoton,&sBoton[41],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[41].iX=bInicioFila+bAnchoBoton*4;
	iBoton[41].iY=bFila;
	iBoton[41].bRepintar=1;
	//}
	iCoordenadaY=bAltoBoton+10;
	iBoton[42]=boton(bAnchoBoton,bAltoBoton,&sBoton[42],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[42].iX=bInicioFila+bAnchoBoton*5;
	iBoton[42].iY=bFila;
	iBoton[42].bRepintar=1;
	//,
	iCoordenadaY=bAltoBoton+10;
	iBoton[43]=boton(bAnchoBoton,bAltoBoton,&sBoton[43],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[43].iX=bInicioFila+bAnchoBoton*6;
	iBoton[43].iY=bFila;
	iBoton[43].bRepintar=1;
	//.
	iCoordenadaY=bAltoBoton+10;
	iBoton[44]=boton(bAnchoBoton,bAltoBoton,&sBoton[44],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[44].iX=bInicioFila+bAnchoBoton*7;
	iBoton[44].iY=bFila;
	iBoton[44].bRepintar=1;
	//-
	iCoordenadaY=bAltoBoton+10;
	iBoton[45]=boton(bAnchoBoton,bAltoBoton,&sBoton[45],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[45].iX=bInicioFila+bAnchoBoton*8;
	iBoton[45].iY=bFila;
	iBoton[45].bRepintar=1;
	//<
	iCoordenadaY=bAltoBoton+10;
	iBoton[46]=boton(bAnchoBoton,bAltoBoton,&sBoton[46],3,0,3,rgb(212,208,200),0,bSeparacion,0, iDrawingZZ, iTextZ);
	iBoton[46].iX=bInicioFila+bAnchoBoton*9;
	iBoton[46].iY=bFila;
	iBoton[46].bRepintar=1;

	iCursor=cursor(iDrawingZZ);
	while (mouse.left)
		frame;
	end
	bAbortar=0;
	repeat
		if (KeyPausa(_JKEY_LEFT))
			iBarraDeslizante.iValor--;
			if (iBarraDeslizante.iValor<0)
				iBarraDeslizante.iValor=0;
			end
			iBarraDeslizante.bRepintar=1;
		end
		if (KeyPausa(_JKEY_right))
			iBarraDeslizante.iValor++;
			if(iBarraDeslizante.iValor>iLongitudTexto)
				iBarraDeslizante.iValor=iLongitudTexto;
			end
			iBarraDeslizante.bRepintar=1;
		end

		//Compruebo movimiento del cursor.
		if (iValorAntiguoBarra!=iBarraDeslizante.iValor)
			iDiferencia=iBarraDeslizante.iValor-iValorAntiguoBarra;
			iPosicionPantalla=iPosicionPantalla+iDiferencia;
			if (iDiferencia>0) //Salto del cursor hacia la derecha.
					iCursor.iX=iCursor.iX+Text_Width(0,substr(sCadena,iValorAntiguoBarra,abs(iDiferencia))); //Incremento posicin del cursor con el salto.
					if (iCursor.iX>319) //Si me he salido de la pantalla, recalculo la posicin del cursor y la nueva cadena a mostrar.
						iContador=0;
						while (Text_Width(0,substr(sCadena,iContador,iBarraDeslizante.iValor-iContador))>319)
							iContador++;
						end
//						sPantalla=substr(sCadena,iContador,iBarraDeslizante.iValor-iContador+1);
						sPantalla=substr(sCadena,iContador,iLongitudTexto);
						iCursor.iX=Text_Width(0,substr(sCadena,iContador,iBarraDeslizante.iValor-iContador));
						iPosicionPantalla=iBarraDeslizante.iValor-iContador;
					end
			else //Salto de cursor hacia la izquierda.
				if(iLongitudTexto<len(sCadenaAntigua))
					iTamanoEnPixelDelSalto=Text_Width(0,sCadenaAntigua)-Text_Width(0,sCadena);
				else
					iTamanoEnPixelDelSalto=Text_Width(0,substr(sCadena,iBarraDeslizante.iValor,abs(iDiferencia)));
				end
				sCadenaAntigua=sCadena;
				if (iTamanoEnPixelDelSalto>iCursor.iX) // Me salgo de la pantalla por la izquierda.
					iCursor.iX=0;
					sPantalla=substr(sCadena,iBarraDeslizante.iValor,iLongitudTexto);
					iPosicionPantalla=0;
				else //No me salgo.
					if (iTamanoEnPixelDelSalto==0)
						iCursor.iX=Text_Width(0,sPantalla);
					else
						iCursor.iX=iCursor.iX-iTamanoEnPixelDelSalto;
					end
				end
			end
			iValorAntiguoBarra=iBarraDeslizante.iValor;
		end
		//Boton Sh
		if (iBotonSh.bPulsado==1)
			if (bLuzVerde==1)
				Drawing_color(rgb(50,255,50));
				Delete_Draw(iLuz);
				iLuz=Draw_fcircle(iBotonSh.iX+5,iBotonSh.iY+5,3);
				bLuzVerde=0;
			else
				Drawing_color(rgb(0,100,0));
				Delete_Draw(iLuz);
				iLuz=Draw_fcircle(iBotonSh.iX+5,iBotonSh.iY+5,3);
				bLuzVerde=1;
			end
			while (iBotonSh.bPulsado==1)
				frame;
			end
		end
		//Boton borrar
		if (iBotonBorrar.bPulsado==1 and iBarraDeslizante.iValor>0)
			sCadenaAntigua=sCadena;
			iLongitudTexto--;
			sCadena=substr(sCadena,0,iBarraDeslizante.iValor-1)
			+substr(sCadena,iBarraDeslizante.iValor,len(sCadena));
			
			iBarraDeslizanteTemporal=Barra_DeslizanteHorizontal(0,320,16,15,0,0,0,0,0,Len(sCadena),
									iValorAntiguoBarra-1, iDrawingZZ, iTextZ);
			iBarraDeslizanteTemporal.iSalto=10;
			iBarraDeslizanteTemporal.iValor=iValorAntiguoBarra-1;
			iBarraDeslizanteTemporal.bRepintar=1;
			frame;
			if (exists(iBarraDeslizante))
				signal(iBarraDeslizante,s_kill_tree);
			end
			iBarraDeslizante=iBarraDeslizanteTemporal;
			sPantalla=substr(sPantalla,0,iPosicionPantalla-1)
			+substr(sPantalla,iPosicionPantalla,len(sPantalla));
			while (iBotonBorrar.bPulsado==1)
				frame;
			end
		end
		//Si ha pulsado algun carcter
		iContador=0;
		while (iContador<=bCaracteres)
			if (iBoton[iContador].bPulsado==1)
				sPantalla=substr(sPantalla,0,iPosicionPantalla)+sCaracter[iContador][bLuzVerde]
				+substr(sPantalla,iPosicionPantalla,len(sPantalla));
				sCadena=substr(sCadena,0,iBarraDeslizante.iValor)+sCaracter[iContador][bLuzVerde]
				+substr(sCadena,iBarraDeslizante.iValor,len(sCadena));
				iLongitudTexto++;
				
				iBarraDeslizanteTemporal=Barra_DeslizanteHorizontal(0,320,16,15,0,0,0,0,0,Len(sCadena),
										iValorAntiguoBarra+1, iDrawingZZ, iTextZ);
				iBarraDeslizanteTemporal.iSalto=10;
				iBarraDeslizanteTemporal.iValor=iValorAntiguoBarra+1;
				iBarraDeslizanteTemporal.bRepintar=1;
				frame;
				if (exists(iBarraDeslizante))
					signal(iBarraDeslizante,s_kill_tree);
				end
				iBarraDeslizante=iBarraDeslizanteTemporal;
				while (iBoton[iContador].bPulsado==1)
					frame;
				end
			end
			iContador++;
		end
		//Boton Cancel
		if (iBotonCancel.bPulsado==1)
			bAbortar=1;
			sCadena="";
			while (iBotonCancel.bPulsado==1)
				frame;
			end
		end

		frame;

	until (iBotonOk.bPulsado==1 or bAbortar)
	while (iBotonOk.bPulsado==1)
		frame;
	end
	//Matando procesos.
	iContador=0;
	while (iContador<=bCaracteres)
		if (exists(iBoton[iContador]))
			signal(iBoton[iContador],s_Kill_Tree);
		end
		iContador++;
	end
	bAbortar=0;
	if (exists(iBotonSH))
		signal(iBotonSH,s_Kill_Tree);
	end
	if (exists(iBotonOK))
		signal(iBotonOK,s_Kill_Tree);
	end
	if (exists(iBotonCancel))
		signal(iBotonCancel,s_Kill_Tree);
	end
	if (exists(iBotonBorrar))
		signal(iBotonBorrar,s_Kill_Tree);
	end
	if (exists(iBarraDeslizante))
		signal(iBarraDeslizante,s_Kill_Tree);
	end

	iContador=0;
	while (iContador<=1)
		delete_draw(iIdeDraw[iContador]);
		iContador++;
	end
	Delete_Draw(iLuz);
	Delete_Text(iIdeCadena);
	if (exists(iCursor))
		signal(iCursor ,s_Kill_Tree);
	end
	frame;
	
	signal(ALL_PROCESS,s_wakeup);
	iDrawingZZ=-150;
	iTextZ=-280;
	Drawing_z(iDrawingZZ);
	Text_z=iTextZ;
	frame;
	return sCadena;
end



//--------------------------------------------------------------------------------------
process Cursor(int iDrawingZ)

private
	int iIde;
	int iAntiguaiX=0;
end


begin
	iX=0;
	drawing_z(iDrawingZ-80);
	drawing_color(rgb(0,255,255));
	iIde=Draw_Box(iX,0,iX,15);
	loop
		drawing_z(iDrawingZ-80);
		drawing_color(rgb(0,255,255));
		if (iIde!=0)
			Delete_Draw(iIde);
			iIde=0;
		else
			iIde=Draw_Box(iX,0,iX+1,15);
		end
		
		if (iX!=iAntiguaiX)
			if (iIde!=0)
				Delete_Draw(iIde);
				iIde=0;
			end
			iIde=Draw_Box(iX,0,iX+1,15);
			iAntiguaiX=iX;
		end
		
		frame(400);
		drawing_z(iDrawingZ+80);
	end
OnExit
	if(iIde!=0)
		delete_draw(iIde);
	end

end
	
	
	
